package test;

import java.util.concurrent.atomic.AtomicBoolean;
import org.json.JSONObject;
import rsx.BomberStudentClient;

/**
 * Exemple appel vers le serveur
 * @author Arthur Brandao
 */
public class ServerTest {
    
    public static AtomicBoolean stop = new AtomicBoolean(false);
    public static int code = -1;

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        //Creation client BomberStudent
        BomberStudentClient bsc = new BomberStudentClient();
        //Ajout handler
        bsc.addHandler("server/end", new HandlerServerEnd());
        //Recherche serveur actif
        int nbRes = bsc.findServer();
        if(nbRes == 0){
            System.err.println("Aucun serveur");
            return;
        }
        //Selectionne le 1er serveur qui à repondu
        bsc.selectServer(0);
        //Attend fin serveur
        System.out.println("Attente");
        while(!stop.get()){
            
        }
        System.out.println("Code : " + code);
        bsc.close();
        //*/
    }
    
}
